﻿@page "/competitions/{Id:int}"

@using Models.CompetitionData
@using Business.Repository.IRepository
@inject ICompetitionRepository CompetitionRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Competitions</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="@($"competitions/create/{Id}")" class="btn btn-primary form-control">Add new competition</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="5%" class="text-center">#</th>
                    <th width="50%" class="text-center">Name</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Competitions.Any())
                {
                    int i = 1;
                    @foreach (var competition in Competitions)
                    {
                        <tr>
                            <td class="text-center">@i</td>
                            @{i++;}
                            <td class="text-center">@competition.Name</td>
                            <td>
                                <NavLink href="@($"competition/competitionDetails/{competition.Id}")" class="btn btn-primary">Details</NavLink>
                                <NavLink href="@($"competitions/edit/{competition.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(competition.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    [Parameter]
    public int? Id { get; set; }
    private IEnumerable<CompetitionDTO> Competitions { get; set; } = new List<CompetitionDTO>();
    private int? DeleteCompetitionId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        Competitions = await CompetitionRepository.GetAllFromCompParent(Id.Value);
    }

    private async Task HandleDelete(int competitionId)
    {
        DeleteCompetitionId = competitionId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteCompetitionId != null)
        {
            await CompetitionRepository.Delete(DeleteCompetitionId.Value);
            await JsRuntime.ToastrSuccess("Competition deleted successfully!");
            Competitions = await CompetitionRepository.GetAllFromCompParent(Id.Value);
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}

